(function(){
    function Window_CustomItemList(){
        this.initialize.apply(this, arguments);
    }

    Window_CustomItemList.prototype = Object.create(Window_ItemList.prototype);
    Window_CustomItemList.prototype.constructor = Window_CustomItemList;
    var SPACE =  (816 - 180 * 4) / 6;

    Window_CustomItemList.prototype._createAllParts = function() {
        this._windowSpriteContainer = new PIXI.DisplayObjectContainer();
        this._windowBackSprite = new Sprite();
        this._windowCursorSprite = new Sprite();
        this._windowFrameSprite = new Sprite();
        this._windowContentsSprite = new Sprite();
        this._downArrowSprite = new Sprite();
        this._upArrowSprite = new Sprite();
        this._windowPauseSignSprite = new Sprite();
        this._windowBackSprite.bitmap = new Bitmap(1, 1);
        this._windowBackSprite.alpha = 192 / 255;
        this.addChild(this._windowSpriteContainer);
        this._windowSpriteContainer.addChild(this._windowBackSprite);
        this._windowSpriteContainer.addChild(this._windowFrameSprite);
        this.addChild(this._windowContentsSprite);
        this.addChild(this._windowCursorSprite);
        this.addChild(this._downArrowSprite);
        this.addChild(this._upArrowSprite);
        this.addChild(this._windowPauseSignSprite);
    };

    Window_CustomItemList.prototype.initialize = function(){
        Window_ItemList.prototype.initialize.apply(this, arguments);
        this.y = 100;
        this.height = 180*2 + SPACE * 3 + this.padding * 2;
        this.width = 816;
        this._category = 'all';
        this.select(0);
        this.setBackgroundType(1);

        this.activate();
        this.refresh();
        this.resetScroll();
    };

    Window_CustomItemList.prototype.select = function(){
        Window_ItemList.prototype.select.apply(this, arguments);

        var symbol_select = 'select';
        if (this.isHandled(symbol_select)) {
            this._handlers[symbol_select](this.item());
        }
    };

    Window_CustomItemList.prototype.maxVisibleItems = function(){
        return 8;
    };

    Window_CustomItemList.prototype.spacing = function(){
        return 0;
    };

    Window_CustomItemList.prototype.itemHeight = function(){
        return 180 + SPACE;
    };

    Window_CustomItemList.prototype.itemWidth = function(){
        return 180 + SPACE;
    };

    Window_CustomItemList.prototype.drawItem = function(index){
        if(!this._data) return;

        var rect = this.itemRect(index);
        var item = this._data[index];
        if(!item) return;

        var image = ImageManager.loadPicture(item.meta['image']);
        if(!image.isReady()){
            var self = this;
            image.addLoadListener(function(){
                self.refresh();
            });
        }

        this.contents.blt(image, 0, 0, 180, 180, rect.x + SPACE/2, rect.y + SPACE/2);
    };

    Window_CustomItemList.prototype.maxCols = function(){
        return 4;
    };

    Window_CustomItemList.prototype.includes = function(item) {
        if(this._category === 'all') return true;
        return Window_ItemList.prototype.includes.call(this, item);
    };

    function Window_ItemDesc(){
        Window_ItemDesc.prototype.initialize.apply(this, arguments);
    }

    Window_ItemDesc.prototype = Object.create(Window_Base.prototype);
    Window_ItemDesc.constructor = Window_ItemDesc;

    Window_ItemDesc.prototype.initialize = function(){
        Window_Base.prototype.initialize.call(this, 0, 0, 816, 100);
        this.setBackgroundType(2);
    };

    Window_ItemDesc.prototype.drawDesc = function(item){
        this.contents.clear();

        if(item){
            this.resetFontSettings();
            this.drawText(item.description, 0, 0, 816, 'center');
        }
    };

    Scene_Item.prototype.create = function(){
        Scene_MenuBase.prototype.create.call(this);
        this._itemWindow = new Window_CustomItemList();
        this._descWindow = new Window_ItemDesc();

        this.addWindow(this._itemWindow);
        this._itemWindow.setHandler('ok', this.onItemOk.bind(this));
        this._itemWindow.setHandler('cancel', this.popScene.bind(this));
        this._itemWindow.open();

        this.addWindow(this._descWindow);
        this._itemWindow.setHandler('select',
            this._descWindow.drawDesc.bind(this._descWindow));
        this._descWindow.open();

        this._itemWindow.select(0);

        this._actorWindow = {
            index: function(){
                return 0;
            }
        };
    };

    Scene_Item.prototype.determineItem = function(){
        this.useItem();
    };

    Scene_Item.prototype.useItem = function() {
        this.playSeForItem();
        this.user().useItem(this.item());
        this.applyItem();
        this.checkCommonEvent();
        this.checkGameover();
    };
})();
